Developer Documentation

Public Member Functions | List of all members
ACG::MeshCompilerFaceInput Class Referenceabstract
Inheritance diagram for ACG::MeshCompilerFaceInput:

## Public Member Functions
virtual int | getNumFaces () const =0
virtual int | getNumIndices () const =0
virtual int | getFaceSize (const int _faceID) const =0
virtual int | getSingleFaceAttr (const int _faceID, const int _faceCorner, const int _attrID) const
virtual bool | getFaceAttr (const int _faceID, const int _attrID, int *_out) const
virtual int * | getFaceAttr (const int _faceID, const int _attrID) const
virtual int | getVertexAdjCount (const int _vertexID) const
virtual int | getVertexAdjFace (const int _vertexID, const int _k) const

## Detailed Description

Definition at line 128 of file MeshCompiler.hh.

## Member Function Documentation

## ◆ getFaceAttr() [1/2]

virtual bool ACG::MeshCompilerFaceInput::getFaceAttr | ( | const int | _faceID,
|  | const int | _attrID,
|  | int * | _out
| ) |  | const
| inline virtual

Get an index buffer of a face for a specific attribute channel.

Parameters

  _faceID | face index
  _attrID | attribute channel
  _out | pointer to output buffer, use getFaceSize(_faceID) to get the size needed to store face data

Returns
  true if successful, false otherwise

Reimplemented in ACG::DrawMeshFaceInput< Mesh >, and ACG::MeshCompilerDefaultFaceInput.

Definition at line 165 of file MeshCompiler.hh.

## ◆ getFaceAttr() [2/2]

virtual int* ACG::MeshCompilerFaceInput::getFaceAttr | ( | const int | _faceID,
|  | const int | _attrID
| ) |  | const
| inline virtual

Get an index buffer of a face for a specific attribute channel.

Parameters

  _faceID | face index
  _attrID | attribute channel

Returns
  array data of size "getFaceSize(_faceID)", allowed to return 0 when array data not permanently available in memory

Reimplemented in ACG::DrawMeshFaceInput< Mesh >.

Definition at line 172 of file MeshCompiler.hh.

## ◆ getFaceSize()

virtual int ACG::MeshCompilerFaceInput::getFaceSize | ( | const int | _faceID | ) | const
| pure virtual

Get number of vertices per face.

Parameters

  _faceID | face index

Implemented in ACG::DrawMeshFaceInput< Mesh >, and ACG::MeshCompilerDefaultFaceInput.

## ◆ getNumIndices()

virtual int ACG::MeshCompilerFaceInput::getNumIndices | ( |  | ) | const
| pure virtual

Get total number of indices in one attribute channel.

i.e. total number of position indices of the whole mesh

Implemented in ACG::DrawMeshFaceInput< Mesh >, and ACG::MeshCompilerDefaultFaceInput.

## ◆ getSingleFaceAttr()

int ACG::MeshCompilerFaceInput::getSingleFaceAttr | ( | const int | _faceID,
|  | const int | _faceCorner,
|  | const int | _attrID
| ) |  | const
| virtual

Get a single vertex-index entry of a face.

Parameters

  _faceID | face index
  _faceCorner | vertex corner of the face
  _attrID | attribute channel

Returns
  index-data if successful, -1 otherwise

Reimplemented in ACG::DrawMeshFaceInput< Mesh >, and ACG::MeshCompilerDefaultFaceInput.

Definition at line 4188 of file MeshCompiler.cc.

## ◆ getVertexAdjCount()

virtual int ACG::MeshCompilerFaceInput::getVertexAdjCount | ( | const int | _vertexID | ) | const
| inline virtual

Get the number of adjacent faces for a vertex.

Parameters

  _vertexID | vertex index

Returns
  number of adjacent faces, return -1 if adjacency information unavailable

Reimplemented in ACG::DrawMeshFaceInput< Mesh >, and SBFReader.

Definition at line 182 of file MeshCompiler.hh.

## ◆ getVertexAdjFace()

virtual int ACG::MeshCompilerFaceInput::getVertexAdjFace | ( | const int | _vertexID,
|  | const int | _k
| ) |  | const
| inline virtual

Get the index of an adjacent face for a vertex.

Parameters

  _vertexID | vertex index
  _k | adjacency list entry in range [0, .., adjCount - 1]

Returns
  face id of adjacent face, return -1 if adjacency information is available

Reimplemented in ACG::DrawMeshFaceInput< Mesh >, and SBFReader.

Definition at line 189 of file MeshCompiler.hh.

The documentation for this class was generated from the following files:

- OpenFlipper/libs_required/ACG/GL/MeshCompiler.hh
- OpenFlipper/libs_required/ACG/GL/MeshCompiler.cc